"""
    Merge Accounting API

    The unified API for building rich integrations with multiple Accounting & Finance platforms.  # noqa: E501

    The version of the OpenAPI document: 1.0
    Contact: hello@merge.dev
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from typing import (
    Optional,
    Union,
    List,
    Dict,
)

from MergePythonSDK.shared.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    OpenApiModel,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
)
from MergePythonSDK.shared.exceptions import ApiAttributeError
from MergePythonSDK.shared.model_utils import import_model_by_name


def lazy_import():
    from MergePythonSDK.accounting.model.currency_enum import CurrencyEnum
    from MergePythonSDK.shared.model.remote_data import RemoteData
    from MergePythonSDK.accounting.model.report_item import ReportItem
    globals()['CurrencyEnum'] = CurrencyEnum
    globals()['RemoteData'] = RemoteData
    globals()['ReportItem'] = ReportItem

class IncomeStatement(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        return (bool, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()

        defined_types = {
            'id': (str, none_type,),  # noqa: E501
            'remote_id': (str, none_type, none_type,),  # noqa: E501
            'remote_data': ([RemoteData], none_type, none_type,),  # noqa: E501
            'name': (str, none_type, none_type,),  # noqa: E501
            'currency': (CurrencyEnum, str, none_type,),
            'start_period': (datetime, none_type, none_type,),  # noqa: E501
            'end_period': (datetime, none_type, none_type,),  # noqa: E501
            'income': ([ReportItem], none_type,),  # noqa: E501
            'cost_of_sales': ([ReportItem], none_type,),  # noqa: E501
            'gross_profit': (float, none_type, none_type,),  # noqa: E501
            'operating_expenses': ([ReportItem], none_type,),  # noqa: E501
            'net_operating_income': (float, none_type, none_type,),  # noqa: E501
            'non_operating_expenses': ([ReportItem], none_type,),  # noqa: E501
            'net_income': (float, none_type, none_type,),  # noqa: E501
            'remote_was_deleted': (bool, none_type,),  # noqa: E501
        }
        return defined_types

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'id': 'id',  # noqa: E501
        'remote_id': 'remote_id',  # noqa: E501
        'remote_data': 'remote_data',  # noqa: E501
        'name': 'name',  # noqa: E501
        'currency': 'currency',  # noqa: E501
        'start_period': 'start_period',  # noqa: E501
        'end_period': 'end_period',  # noqa: E501
        'income': 'income',  # noqa: E501
        'cost_of_sales': 'cost_of_sales',  # noqa: E501
        'gross_profit': 'gross_profit',  # noqa: E501
        'operating_expenses': 'operating_expenses',  # noqa: E501
        'net_operating_income': 'net_operating_income',  # noqa: E501
        'non_operating_expenses': 'non_operating_expenses',  # noqa: E501
        'net_income': 'net_income',  # noqa: E501
        'remote_was_deleted': 'remote_was_deleted',  # noqa: E501
    }

    read_only_vars = {
        'id',  # noqa: E501
        'remote_data',  # noqa: E501
        'income',  # noqa: E501
        'cost_of_sales',  # noqa: E501
        'operating_expenses',  # noqa: E501
        'non_operating_expenses',  # noqa: E501
        'remote_was_deleted',  # noqa: E501
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, *args, **kwargs):  # noqa: E501
        """IncomeStatement - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            id (str): [optional]  # noqa: E501
            remote_id (str, none_type): The third-party API ID of the matching object.. [optional]  # noqa: E501
            remote_data ([RemoteData], none_type): [optional]  # noqa: E501
            name (str, none_type): The income statement's name.. [optional]  # noqa: E501
            currency (bool, dict, float, int, list, str, none_type): The income statement's currency.. [optional]  # noqa: E501
            start_period (datetime, none_type): The income statement's start period.. [optional]  # noqa: E501
            end_period (datetime, none_type): The income statement's end period.. [optional]  # noqa: E501
            income ([ReportItem]): [optional]  # noqa: E501
            cost_of_sales ([ReportItem]): [optional]  # noqa: E501
            gross_profit (float, none_type): The income statement's gross profit.. [optional]  # noqa: E501
            operating_expenses ([ReportItem]): [optional]  # noqa: E501
            net_operating_income (float, none_type): The income statement's net operating profit.. [optional]  # noqa: E501
            non_operating_expenses ([ReportItem]): [optional]  # noqa: E501
            net_income (float, none_type): The income statement's net income.. [optional]  # noqa: E501
            remote_was_deleted (bool): Indicates whether or not this object has been deleted by third party webhooks.. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', True)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)


        self.remote_id = kwargs.get("remote_id", None)
        self.name = kwargs.get("name", None)
        self.currency = kwargs.get("currency", None)
        self.start_period = kwargs.get("start_period", None)
        self.end_period = kwargs.get("end_period", None)
        self.gross_profit = kwargs.get("gross_profit", None)
        self.net_operating_income = kwargs.get("net_operating_income", None)
        self.net_income = kwargs.get("net_income", None)

        # Read only properties
        self._id = kwargs.get("id", str())
        self._remote_data = kwargs.get("remote_data", None)
        self._income = kwargs.get("income", None)
        self._cost_of_sales = kwargs.get("cost_of_sales", None)
        self._operating_expenses = kwargs.get("operating_expenses", None)
        self._non_operating_expenses = kwargs.get("non_operating_expenses", None)
        self._remote_was_deleted = kwargs.get("remote_was_deleted", bool())
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """IncomeStatement - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            id (str): [optional]  # noqa: E501
            remote_id (str, none_type): The third-party API ID of the matching object.. [optional]  # noqa: E501
            remote_data ([RemoteData], none_type): [optional]  # noqa: E501
            name (str, none_type): The income statement's name.. [optional]  # noqa: E501
            currency (bool, dict, float, int, list, str, none_type): The income statement's currency.. [optional]  # noqa: E501
            start_period (datetime, none_type): The income statement's start period.. [optional]  # noqa: E501
            end_period (datetime, none_type): The income statement's end period.. [optional]  # noqa: E501
            income ([ReportItem]): [optional]  # noqa: E501
            cost_of_sales ([ReportItem]): [optional]  # noqa: E501
            gross_profit (float, none_type): The income statement's gross profit.. [optional]  # noqa: E501
            operating_expenses ([ReportItem]): [optional]  # noqa: E501
            net_operating_income (float, none_type): The income statement's net operating profit.. [optional]  # noqa: E501
            non_operating_expenses ([ReportItem]): [optional]  # noqa: E501
            net_income (float, none_type): The income statement's net income.. [optional]  # noqa: E501
            remote_was_deleted (bool): Indicates whether or not this object has been deleted by third party webhooks.. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.remote_id: Union[str, none_type] = kwargs.get("remote_id", None)
        self.name: Union[str, none_type] = kwargs.get("name", None)
        self.currency: Union[bool, dict, float, int, list, str, none_type] = kwargs.get("currency", None)
        self.start_period: Union[datetime, none_type] = kwargs.get("start_period", None)
        self.end_period: Union[datetime, none_type] = kwargs.get("end_period", None)
        self.gross_profit: Union[float, none_type] = kwargs.get("gross_profit", None)
        self.net_operating_income: Union[float, none_type] = kwargs.get("net_operating_income", None)
        self.net_income: Union[float, none_type] = kwargs.get("net_income", None)

        # Read only properties
        self._id: Union[str] = kwargs.get("id", str())
        self._remote_data: Union[List["RemoteData"]] = kwargs.get("remote_data", None)
        self._income: Union[List["ReportItem"]] = kwargs.get("income", None)
        self._cost_of_sales: Union[List["ReportItem"]] = kwargs.get("cost_of_sales", None)
        self._operating_expenses: Union[List["ReportItem"]] = kwargs.get("operating_expenses", None)
        self._non_operating_expenses: Union[List["ReportItem"]] = kwargs.get("non_operating_expenses", None)
        self._remote_was_deleted: Union[bool] = kwargs.get("remote_was_deleted", bool())

    # Read only property getters
    @property
    def id(self):
        return self._id

    @property
    def remote_data(self):
        return self._remote_data

    @property
    def income(self):
        return self._income

    @property
    def cost_of_sales(self):
        return self._cost_of_sales

    @property
    def operating_expenses(self):
        return self._operating_expenses

    @property
    def non_operating_expenses(self):
        return self._non_operating_expenses

    @property
    def remote_was_deleted(self):
        return self._remote_was_deleted



